/*$Id: acre_fdl_times_vec.c,v 1.1 2004/04/30 Joel M. Malard Exp d3j540 $ */

#include "tao_solver.h"
#include "petscblaslapack.h"
#include "petsclog.h"
#include "acre.h"
#include "petsclog.h"
#include <assert.h>
#include <mpi.h>
#include <math.h>
#include "copyright.h"
#undef __FUNC__
#define __FUNC__ "acre_fdl_times_vec"
int acre_fdl_times_vec( acre_cntxt *cntxt, int p, Vec u, Vec v,
	int flag, IS *fiS, IS *tiS, VecScatter *iScatter)
{
	int ierr;
	PetscScalar zero = 0.0;

	HELLO("acre_fdl_times_vec enter");

	ierr = VecSet ( &zero, v );			CHKERRQ(ierr);
	if(flag==ACRE_NO_TRANSPOSE)
	{ 
		ierr = VecScatterBegin ( u, v,
			INSERT_VALUES, SCATTER_FORWARD,
			*iScatter );			CHKERRQ(ierr);
		ierr = VecScatterEnd ( u, v,
			INSERT_VALUES, SCATTER_FORWARD,
			*iScatter );			CHKERRQ(ierr);
	}
	else
	{ 
		ierr = VecScatterBegin ( u, v,
			INSERT_VALUES, SCATTER_REVERSE,
			*iScatter );			CHKERRQ(ierr);
		ierr = VecScatterEnd ( u, v,
			INSERT_VALUES, SCATTER_REVERSE,
			*iScatter );			CHKERRQ(ierr);
	}

	HELLO("acre_fdl_times_vec exit");

	return 0;

}
