/*$Id: acre_matrix_view.c,v 1.1 2004/04/30 Joel M. Malard Exp d3j540 $ */

#include "tao_solver.h"
#include "petscblaslapack.h"
#include "petsclog.h"
#include "acre.h"
#include "petsclog.h"
#include <assert.h>
#include <mpi.h>
#include <math.h>
#include "copyright.h"
#undef __FUNC__  
#define __FUNC__ "acre_matrix_view"
int acre_matrix_view(acre_cntxt *cntxt, Mat A , char *msg)
{
	int here, rank;
	int ierr,i,j;
	int start, end, nrows;
	PetscScalar *avals;

	HELLO("acre_matrix_view enter");

	ierr = MPI_Comm_rank(MPI_COMM_WORLD,&here);
		assert(ierr==MPI_SUCCESS);

	ierr = MPI_Comm_rank(cntxt->rcomm,&rank);
		assert(ierr==MPI_SUCCESS);

	ierr = MatGetOwnershipRange(A,&start,&end);		CHKERRQ(ierr);
	nrows = end-start;

	ierr = MatGetArray(A,&avals);				CHKERRQ(ierr);
	for ( i=0;i<nrows; i++)
	{
		for ( j=0; j<cntxt->rn; j++)
		{
			PetscPrintf(PETSC_COMM_SELF,
			"<%d> %s:\t%d %d = %lg\n",
			here,msg,i+start,
			j+cntxt->rstart[rank],
			avals[i+j*nrows]);
		}
	}

	HELLO("acre_matrix_view exit");

	return 0;
}
