/*$Id: acre_read_aij_matrix.c,v 1.1 2004/04/30 Joel M. Malard Exp d3j540 $ */

#include <stdlib.h>
#include <assert.h>
#include "tao.h"
#include "acre.h"
#include "petscmat.h" 
#include "copyright.h"
#undef __FUNC__
#define __FUNC__ "acre_read_aij_matrix"

int acre_read_aij_matrix(MPI_Comm comm, char * infile, PetscTruth format,
	Mat * A)
{
	int ierr;

	HELLO("acre_read_aij_matrix enter");

	if ( format==PETSC_TRUE )
	{
		int i, j;
		int m, n;
		FILE *fp;
		PetscScalar val;
		fp = fopen(infile,"r");
			assert(fp!=NULL);
		ierr = fscanf(fp, "%d\t%d\n",&m,&n);
			assert(ierr==2);

		ierr = MatCreateMPIAIJ( comm,
			PETSC_DECIDE, PETSC_DECIDE,
			m, n, n, PETSC_NULL, 
			n, PETSC_NULL, A);			CHKERRQ(ierr);
		do
		{
			ierr = fscanf(fp,"%d %d %lg",
				&i,&j,&val);
			MatSetValue( *A, i, j, val,
				INSERT_VALUES);
		} while (ierr==3) ;
		ierr = MatAssemblyBegin(*A,
			MAT_FINAL_ASSEMBLY); 			CHKERRQ(ierr);
		ierr = MatAssemblyEnd(*A,
			MAT_FINAL_ASSEMBLY); 			CHKERRQ(ierr);

		fclose(fp);

	}
	else
	{
		PetscViewer  fd;
		ierr = PetscViewerBinaryOpen(PETSC_COMM_WORLD,
			infile, PETSC_FILE_RDONLY,&fd);		CHKERRQ(ierr);
		ierr = MatLoad(fd, MATMPIAIJ, A);		CHKERRQ(ierr);
		ierr = PetscViewerDestroy(fd);			CHKERRQ(ierr);
	}

	HELLO("acre_read_aij_matrix exit");

	return ierr;
}
